/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreatePlanCommand } from '../models';
import { CreatePlanHospitalCommand } from '../models';
import { PlanHospitalModel } from '../models';
import { PlanHospitalsModel } from '../models';
import { PlanModel } from '../models';
import { PlansModel } from '../models';
import { UpdatePlanCommand } from '../models';
import { UpdatePlanHospitalCommand } from '../models';
/**
 * PlansApi - axios parameter creator
 * @export
 */
export declare const PlansApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all plans.
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansGet: (id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdDelete: (planId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdGet: (planId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all plan hospital.
     * @param {string} planId
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsGet: (planId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdDelete: (planId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdGet: (planId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdPut: (planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create plan hospital.
     * @param {string} planId
     * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsPost: (planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update plan.
     * @param {string} planId
     * @param {UpdatePlanCommand} [updatePlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdPut: (planId: string, updatePlanCommand?: UpdatePlanCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a plan.
     * @param {CreatePlanCommand} [createPlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPost: (createPlanCommand?: CreatePlanCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * PlansApi - functional programming interface
 * @export
 */
export declare const PlansApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all plans.
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlansModel>>;
    /**
     *
     * @summary Delete plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdDelete(planId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdGet(planId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>>;
    /**
     *
     * @summary Get all plan hospital.
     * @param {string} planId
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsGet(planId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalsModel>>;
    /**
     *
     * @summary Delete plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdDelete(planId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdGet(planId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>>;
    /**
     *
     * @summary Update plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdPut(planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>>;
    /**
     *
     * @summary Create plan hospital.
     * @param {string} planId
     * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsPost(planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanHospitalModel>>;
    /**
     *
     * @summary Update plan.
     * @param {string} planId
     * @param {UpdatePlanCommand} [updatePlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdPut(planId: string, updatePlanCommand?: UpdatePlanCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>>;
    /**
     *
     * @summary Create a plan.
     * @param {CreatePlanCommand} [createPlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPost(createPlanCommand?: CreatePlanCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PlanModel>>;
};
/**
 * PlansApi - factory interface
 * @export
 */
export declare const PlansApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all plans.
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PlansModel>;
    /**
     *
     * @summary Delete plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdDelete(planId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get plan.
     * @param {string} planId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdGet(planId: string, options?: any): AxiosPromise<PlanModel>;
    /**
     *
     * @summary Get all plan hospital.
     * @param {string} planId
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsGet(planId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PlanHospitalsModel>;
    /**
     *
     * @summary Delete plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdDelete(planId: string, hospitalId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdGet(planId: string, hospitalId: string, options?: any): AxiosPromise<PlanHospitalModel>;
    /**
     *
     * @summary Update plan hospital.
     * @param {string} planId
     * @param {string} hospitalId
     * @param {UpdatePlanHospitalCommand} [updatePlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsHospitalIdPut(planId: string, hospitalId: string, updatePlanHospitalCommand?: UpdatePlanHospitalCommand, options?: any): AxiosPromise<PlanHospitalModel>;
    /**
     *
     * @summary Create plan hospital.
     * @param {string} planId
     * @param {CreatePlanHospitalCommand} [createPlanHospitalCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdHospitalsPost(planId: string, createPlanHospitalCommand?: CreatePlanHospitalCommand, options?: any): AxiosPromise<PlanHospitalModel>;
    /**
     *
     * @summary Update plan.
     * @param {string} planId
     * @param {UpdatePlanCommand} [updatePlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPlanIdPut(planId: string, updatePlanCommand?: UpdatePlanCommand, options?: any): AxiosPromise<PlanModel>;
    /**
     *
     * @summary Create a plan.
     * @param {CreatePlanCommand} [createPlanCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PlansPost(createPlanCommand?: CreatePlanCommand, options?: any): AxiosPromise<PlanModel>;
};
/**
 * Request parameters for apiV1PlansGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansGetRequest
 */
export interface PlansApiApiV1PlansGetRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly name?: string;
    /**
     *
     * @type {number}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof PlansApiApiV1PlansGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1PlansPlanIdDelete operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdDeleteRequest
 */
export interface PlansApiApiV1PlansPlanIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdDelete
     */
    readonly planId: string;
}
/**
 * Request parameters for apiV1PlansPlanIdGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdGetRequest
 */
export interface PlansApiApiV1PlansPlanIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdGet
     */
    readonly planId: string;
}
/**
 * Request parameters for apiV1PlansPlanIdHospitalsGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsGetRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsGetRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly planId: string;
    /**
     *
     * @type {number}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdDelete operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdDelete
     */
    readonly planId: string;
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdGet operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdGet
     */
    readonly planId: string;
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdGet
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1PlansPlanIdHospitalsHospitalIdPut operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly planId: string;
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly hospitalId: string;
    /**
     *
     * @type {UpdatePlanHospitalCommand}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsHospitalIdPut
     */
    readonly updatePlanHospitalCommand?: UpdatePlanHospitalCommand;
}
/**
 * Request parameters for apiV1PlansPlanIdHospitalsPost operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdHospitalsPostRequest
 */
export interface PlansApiApiV1PlansPlanIdHospitalsPostRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsPost
     */
    readonly planId: string;
    /**
     *
     * @type {CreatePlanHospitalCommand}
     * @memberof PlansApiApiV1PlansPlanIdHospitalsPost
     */
    readonly createPlanHospitalCommand?: CreatePlanHospitalCommand;
}
/**
 * Request parameters for apiV1PlansPlanIdPut operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPlanIdPutRequest
 */
export interface PlansApiApiV1PlansPlanIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof PlansApiApiV1PlansPlanIdPut
     */
    readonly planId: string;
    /**
     *
     * @type {UpdatePlanCommand}
     * @memberof PlansApiApiV1PlansPlanIdPut
     */
    readonly updatePlanCommand?: UpdatePlanCommand;
}
/**
 * Request parameters for apiV1PlansPost operation in PlansApi.
 * @export
 * @interface PlansApiApiV1PlansPostRequest
 */
export interface PlansApiApiV1PlansPostRequest {
    /**
     *
     * @type {CreatePlanCommand}
     * @memberof PlansApiApiV1PlansPost
     */
    readonly createPlanCommand?: CreatePlanCommand;
}
/**
 * PlansApi - object-oriented interface
 * @export
 * @class PlansApi
 * @extends {BaseAPI}
 */
export declare class PlansApi extends BaseAPI {
    /**
     *
     * @summary Get all plans.
     * @param {PlansApiApiV1PlansGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansGet(requestParameters?: PlansApiApiV1PlansGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlansModel, any>>;
    /**
     *
     * @summary Delete plan.
     * @param {PlansApiApiV1PlansPlanIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdDelete(requestParameters: PlansApiApiV1PlansPlanIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get plan.
     * @param {PlansApiApiV1PlansPlanIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdGet(requestParameters: PlansApiApiV1PlansPlanIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanModel, any>>;
    /**
     *
     * @summary Get all plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdHospitalsGet(requestParameters: PlansApiApiV1PlansPlanIdHospitalsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanHospitalsModel, any>>;
    /**
     *
     * @summary Delete plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdHospitalsHospitalIdDelete(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdHospitalsHospitalIdGet(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanHospitalModel, any>>;
    /**
     *
     * @summary Update plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdHospitalsHospitalIdPut(requestParameters: PlansApiApiV1PlansPlanIdHospitalsHospitalIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanHospitalModel, any>>;
    /**
     *
     * @summary Create plan hospital.
     * @param {PlansApiApiV1PlansPlanIdHospitalsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdHospitalsPost(requestParameters: PlansApiApiV1PlansPlanIdHospitalsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanHospitalModel, any>>;
    /**
     *
     * @summary Update plan.
     * @param {PlansApiApiV1PlansPlanIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPlanIdPut(requestParameters: PlansApiApiV1PlansPlanIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanModel, any>>;
    /**
     *
     * @summary Create a plan.
     * @param {PlansApiApiV1PlansPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PlansApi
     */
    apiV1PlansPost(requestParameters?: PlansApiApiV1PlansPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PlanModel, any>>;
}
//# sourceMappingURL=plans-api.d.ts.map