/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { HeaderNavigationItemModel } from '../models';
// @ts-ignore
import { SaveHeaderNavigationsCommand } from '../models';
/**
 * HeaderNavigationsApi - axios parameter creator
 * @export
 */
export const HeaderNavigationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all HeaderNavigationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeGet: async (languageCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeGet', 'languageCode', languageCode)
            const localVarPath = `/api/v1/headernavigations/{languageCode}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete HeaderNavigationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeIdDelete: async (languageCode: string, id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeIdDelete', 'languageCode', languageCode)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeIdDelete', 'id', id)
            const localVarPath = `/api/v1/headernavigations/{languageCode}/{id}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get HeaderNavigationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeIdGet: async (languageCode: string, id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeIdGet', 'languageCode', languageCode)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeIdGet', 'id', id)
            const localVarPath = `/api/v1/headernavigations/{languageCode}/{id}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get HeaderNavigationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet: async (languageCode: string, parentId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet', 'languageCode', languageCode)
            // verify required parameter 'parentId' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet', 'parentId', parentId)
            const localVarPath = `/api/v1/headernavigations/{languageCode}/{parentId}/subitems`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"parentId"}}`, encodeURIComponent(String(parentId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Save HeaderNavigationItem
         * @param {string} languageCode 
         * @param {SaveHeaderNavigationsCommand} [saveHeaderNavigationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodePost: async (languageCode: string, saveHeaderNavigationsCommand?: SaveHeaderNavigationsCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1HeadernavigationsLanguageCodePost', 'languageCode', languageCode)
            const localVarPath = `/api/v1/headernavigations/{languageCode}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(saveHeaderNavigationsCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * HeaderNavigationsApi - functional programming interface
 * @export
 */
export const HeaderNavigationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = HeaderNavigationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all HeaderNavigationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HeadernavigationsLanguageCodeGet(languageCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<HeaderNavigationItemModel>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HeadernavigationsLanguageCodeGet(languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete HeaderNavigationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HeadernavigationsLanguageCodeIdDelete(languageCode: string, id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HeadernavigationsLanguageCodeIdDelete(languageCode, id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get HeaderNavigationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HeadernavigationsLanguageCodeIdGet(languageCode: string, id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HeaderNavigationItemModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HeadernavigationsLanguageCodeIdGet(languageCode, id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get HeaderNavigationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(languageCode: string, parentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<HeaderNavigationItemModel>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(languageCode, parentId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Save HeaderNavigationItem
         * @param {string} languageCode 
         * @param {SaveHeaderNavigationsCommand} [saveHeaderNavigationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1HeadernavigationsLanguageCodePost(languageCode: string, saveHeaderNavigationsCommand?: SaveHeaderNavigationsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HeaderNavigationItemModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1HeadernavigationsLanguageCodePost(languageCode, saveHeaderNavigationsCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * HeaderNavigationsApi - factory interface
 * @export
 */
export const HeaderNavigationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = HeaderNavigationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all HeaderNavigationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeGet(languageCode: string, options?: any): AxiosPromise<Array<HeaderNavigationItemModel>> {
            return localVarFp.apiV1HeadernavigationsLanguageCodeGet(languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete HeaderNavigationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeIdDelete(languageCode: string, id: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1HeadernavigationsLanguageCodeIdDelete(languageCode, id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get HeaderNavigationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeIdGet(languageCode: string, id: string, options?: any): AxiosPromise<HeaderNavigationItemModel> {
            return localVarFp.apiV1HeadernavigationsLanguageCodeIdGet(languageCode, id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get HeaderNavigationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(languageCode: string, parentId: string, options?: any): AxiosPromise<Array<HeaderNavigationItemModel>> {
            return localVarFp.apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(languageCode, parentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Save HeaderNavigationItem
         * @param {string} languageCode 
         * @param {SaveHeaderNavigationsCommand} [saveHeaderNavigationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1HeadernavigationsLanguageCodePost(languageCode: string, saveHeaderNavigationsCommand?: SaveHeaderNavigationsCommand, options?: any): AxiosPromise<HeaderNavigationItemModel> {
            return localVarFp.apiV1HeadernavigationsLanguageCodePost(languageCode, saveHeaderNavigationsCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1HeadernavigationsLanguageCodeGet operation in HeaderNavigationsApi.
 * @export
 * @interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeGetRequest
 */
export interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeGet
     */
    readonly languageCode: string
}

/**
 * Request parameters for apiV1HeadernavigationsLanguageCodeIdDelete operation in HeaderNavigationsApi.
 * @export
 * @interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDeleteRequest
 */
export interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDelete
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDelete
     */
    readonly id: string
}

/**
 * Request parameters for apiV1HeadernavigationsLanguageCodeIdGet operation in HeaderNavigationsApi.
 * @export
 * @interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGetRequest
 */
export interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGet
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGet
     */
    readonly id: string
}

/**
 * Request parameters for apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet operation in HeaderNavigationsApi.
 * @export
 * @interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGetRequest
 */
export interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGet
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGet
     */
    readonly parentId: string
}

/**
 * Request parameters for apiV1HeadernavigationsLanguageCodePost operation in HeaderNavigationsApi.
 * @export
 * @interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePostRequest
 */
export interface HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePostRequest {
    /**
     * 
     * @type {string}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePost
     */
    readonly languageCode: string

    /**
     * 
     * @type {SaveHeaderNavigationsCommand}
     * @memberof HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePost
     */
    readonly saveHeaderNavigationsCommand?: SaveHeaderNavigationsCommand
}

/**
 * HeaderNavigationsApi - object-oriented interface
 * @export
 * @class HeaderNavigationsApi
 * @extends {BaseAPI}
 */
export class HeaderNavigationsApi extends BaseAPI {
    /**
     * 
     * @summary Get all HeaderNavigationItems
     * @param {HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HeaderNavigationsApi
     */
    public apiV1HeadernavigationsLanguageCodeGet(requestParameters: HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeGetRequest, options?: AxiosRequestConfig) {
        return HeaderNavigationsApiFp(this.configuration).apiV1HeadernavigationsLanguageCodeGet(requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete HeaderNavigationItem
     * @param {HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HeaderNavigationsApi
     */
    public apiV1HeadernavigationsLanguageCodeIdDelete(requestParameters: HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdDeleteRequest, options?: AxiosRequestConfig) {
        return HeaderNavigationsApiFp(this.configuration).apiV1HeadernavigationsLanguageCodeIdDelete(requestParameters.languageCode, requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get HeaderNavigationItem by id
     * @param {HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HeaderNavigationsApi
     */
    public apiV1HeadernavigationsLanguageCodeIdGet(requestParameters: HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeIdGetRequest, options?: AxiosRequestConfig) {
        return HeaderNavigationsApiFp(this.configuration).apiV1HeadernavigationsLanguageCodeIdGet(requestParameters.languageCode, requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get HeaderNavigationItems by parent id
     * @param {HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HeaderNavigationsApi
     */
    public apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(requestParameters: HeaderNavigationsApiApiV1HeadernavigationsLanguageCodeParentIdSubitemsGetRequest, options?: AxiosRequestConfig) {
        return HeaderNavigationsApiFp(this.configuration).apiV1HeadernavigationsLanguageCodeParentIdSubitemsGet(requestParameters.languageCode, requestParameters.parentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Save HeaderNavigationItem
     * @param {HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HeaderNavigationsApi
     */
    public apiV1HeadernavigationsLanguageCodePost(requestParameters: HeaderNavigationsApiApiV1HeadernavigationsLanguageCodePostRequest, options?: AxiosRequestConfig) {
        return HeaderNavigationsApiFp(this.configuration).apiV1HeadernavigationsLanguageCodePost(requestParameters.languageCode, requestParameters.saveHeaderNavigationsCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
