/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { MembersModel } from '../models';
// @ts-ignore
import { MembershipModel } from '../models';
// @ts-ignore
import { MembershipsModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
/**
 * MembershipsApi - axios parameter creator
 * @export
 */
export const MembershipsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all memberships.
         * @param {string} [id] 
         * @param {string} [planId] 
         * @param {string} [planName] 
         * @param {string} [ownerId] 
         * @param {string} [ownerName] 
         * @param {boolean} [isActive] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsGet: async (id?: string, planId?: string, planName?: string, ownerId?: string, ownerName?: string, isActive?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/memberships`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (planId !== undefined) {
                localVarQueryParameter['PlanId'] = planId;
            }

            if (planName !== undefined) {
                localVarQueryParameter['PlanName'] = planName;
            }

            if (ownerId !== undefined) {
                localVarQueryParameter['OwnerId'] = ownerId;
            }

            if (ownerName !== undefined) {
                localVarQueryParameter['OwnerName'] = ownerName;
            }

            if (isActive !== undefined) {
                localVarQueryParameter['IsActive'] = isActive;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get membership.
         * @param {string} membershipId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsMembershipIdGet: async (membershipId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'membershipId' is not null or undefined
            assertParamExists('apiV1MembershipsMembershipIdGet', 'membershipId', membershipId)
            const localVarPath = `/api/v1/memberships/{membershipId}`
                .replace(`{${"membershipId"}}`, encodeURIComponent(String(membershipId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all members.
         * @param {string} membershipId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsMembershipIdMembersGet: async (membershipId: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'membershipId' is not null or undefined
            assertParamExists('apiV1MembershipsMembershipIdMembersGet', 'membershipId', membershipId)
            const localVarPath = `/api/v1/memberships/{membershipId}/members`
                .replace(`{${"membershipId"}}`, encodeURIComponent(String(membershipId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * MembershipsApi - functional programming interface
 * @export
 */
export const MembershipsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = MembershipsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all memberships.
         * @param {string} [id] 
         * @param {string} [planId] 
         * @param {string} [planName] 
         * @param {string} [ownerId] 
         * @param {string} [ownerName] 
         * @param {boolean} [isActive] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MembershipsGet(id?: string, planId?: string, planName?: string, ownerId?: string, ownerName?: string, isActive?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MembershipsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MembershipsGet(id, planId, planName, ownerId, ownerName, isActive, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get membership.
         * @param {string} membershipId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MembershipsMembershipIdGet(membershipId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MembershipModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MembershipsMembershipIdGet(membershipId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all members.
         * @param {string} membershipId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MembershipsMembershipIdMembersGet(membershipId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MembersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MembershipsMembershipIdMembersGet(membershipId, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * MembershipsApi - factory interface
 * @export
 */
export const MembershipsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = MembershipsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all memberships.
         * @param {string} [id] 
         * @param {string} [planId] 
         * @param {string} [planName] 
         * @param {string} [ownerId] 
         * @param {string} [ownerName] 
         * @param {boolean} [isActive] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsGet(id?: string, planId?: string, planName?: string, ownerId?: string, ownerName?: string, isActive?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MembershipsModel> {
            return localVarFp.apiV1MembershipsGet(id, planId, planName, ownerId, ownerName, isActive, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get membership.
         * @param {string} membershipId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsMembershipIdGet(membershipId: string, options?: any): AxiosPromise<MembershipModel> {
            return localVarFp.apiV1MembershipsMembershipIdGet(membershipId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all members.
         * @param {string} membershipId 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MembershipsMembershipIdMembersGet(membershipId: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MembersModel> {
            return localVarFp.apiV1MembershipsMembershipIdMembersGet(membershipId, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1MembershipsGet operation in MembershipsApi.
 * @export
 * @interface MembershipsApiApiV1MembershipsGetRequest
 */
export interface MembershipsApiApiV1MembershipsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly planId?: string

    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly planName?: string

    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly ownerId?: string

    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly ownerName?: string

    /**
     * 
     * @type {boolean}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly isActive?: boolean

    /**
     * 
     * @type {number}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof MembershipsApiApiV1MembershipsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1MembershipsMembershipIdGet operation in MembershipsApi.
 * @export
 * @interface MembershipsApiApiV1MembershipsMembershipIdGetRequest
 */
export interface MembershipsApiApiV1MembershipsMembershipIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsMembershipIdGet
     */
    readonly membershipId: string
}

/**
 * Request parameters for apiV1MembershipsMembershipIdMembersGet operation in MembershipsApi.
 * @export
 * @interface MembershipsApiApiV1MembershipsMembershipIdMembersGetRequest
 */
export interface MembershipsApiApiV1MembershipsMembershipIdMembersGetRequest {
    /**
     * 
     * @type {string}
     * @memberof MembershipsApiApiV1MembershipsMembershipIdMembersGet
     */
    readonly membershipId: string

    /**
     * 
     * @type {number}
     * @memberof MembershipsApiApiV1MembershipsMembershipIdMembersGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof MembershipsApiApiV1MembershipsMembershipIdMembersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof MembershipsApiApiV1MembershipsMembershipIdMembersGet
     */
    readonly lastRetrieved?: Date
}

/**
 * MembershipsApi - object-oriented interface
 * @export
 * @class MembershipsApi
 * @extends {BaseAPI}
 */
export class MembershipsApi extends BaseAPI {
    /**
     * 
     * @summary Get all memberships.
     * @param {MembershipsApiApiV1MembershipsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MembershipsApi
     */
    public apiV1MembershipsGet(requestParameters: MembershipsApiApiV1MembershipsGetRequest = {}, options?: AxiosRequestConfig) {
        return MembershipsApiFp(this.configuration).apiV1MembershipsGet(requestParameters.id, requestParameters.planId, requestParameters.planName, requestParameters.ownerId, requestParameters.ownerName, requestParameters.isActive, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get membership.
     * @param {MembershipsApiApiV1MembershipsMembershipIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MembershipsApi
     */
    public apiV1MembershipsMembershipIdGet(requestParameters: MembershipsApiApiV1MembershipsMembershipIdGetRequest, options?: AxiosRequestConfig) {
        return MembershipsApiFp(this.configuration).apiV1MembershipsMembershipIdGet(requestParameters.membershipId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all members.
     * @param {MembershipsApiApiV1MembershipsMembershipIdMembersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MembershipsApi
     */
    public apiV1MembershipsMembershipIdMembersGet(requestParameters: MembershipsApiApiV1MembershipsMembershipIdMembersGetRequest, options?: AxiosRequestConfig) {
        return MembershipsApiFp(this.configuration).apiV1MembershipsMembershipIdMembersGet(requestParameters.membershipId, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }
}
