/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { CreateServiceReviewCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { ReviewType } from '../models';
// @ts-ignore
import { ServiceReviewModel } from '../models';
// @ts-ignore
import { ServiceReviewsModel } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
// @ts-ignore
import { UpdateServiceReviewCommand } from '../models';
/**
 * ServiceReviewsApi - axios parameter creator
 * @export
 */
export const ServiceReviewsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all ServiceReviews.
         * @param {string} [id] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [patientId] 
         * @param {string} [patientName] 
         * @param {Gender} [gender] 
         * @param {boolean} [recommended] 
         * @param {number} [rate] 
         * @param {ReviewType} [reviewType] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsGet: async (id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/servicereviews`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (serviceId !== undefined) {
                localVarQueryParameter['ServiceId'] = serviceId;
            }

            if (serviceName !== undefined) {
                localVarQueryParameter['ServiceName'] = serviceName;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (patientId !== undefined) {
                localVarQueryParameter['PatientId'] = patientId;
            }

            if (patientName !== undefined) {
                localVarQueryParameter['PatientName'] = patientName;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (recommended !== undefined) {
                localVarQueryParameter['Recommended'] = recommended;
            }

            if (rate !== undefined) {
                localVarQueryParameter['Rate'] = rate;
            }

            if (reviewType !== undefined) {
                localVarQueryParameter['ReviewType'] = reviewType;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a ServiceReview.
         * @param {CreateServiceReviewCommand} [createServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsPost: async (createServiceReviewCommand?: CreateServiceReviewCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/servicereviews`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createServiceReviewCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete ServiceReview.
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdDelete: async (serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdDelete', 'serviceReviewId', serviceReviewId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdGet: async (serviceReviewId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdGet', 'serviceReviewId', serviceReviewId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all ServiceReviewMedias.
         * @param {string} serviceReviewId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasGet: async (serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasGet', 'serviceReviewId', serviceReviewId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}/medias`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete ServiceReviewMedia
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete: async (serviceReviewId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete', 'serviceReviewId', serviceReviewId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}/medias/{mediaId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdGet: async (serviceReviewId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdGet', 'serviceReviewId', serviceReviewId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}/medias/{mediaId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdPut: async (serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdPut', 'serviceReviewId', serviceReviewId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}/medias/{mediaId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasPost: async (serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdMediasPost', 'serviceReviewId', serviceReviewId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}/medias`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update ServiceReview.
         * @param {string} serviceReviewId 
         * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdPut: async (serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceReviewId' is not null or undefined
            assertParamExists('apiV1ServicereviewsServiceReviewIdPut', 'serviceReviewId', serviceReviewId)
            const localVarPath = `/api/v1/servicereviews/{serviceReviewId}`
                .replace(`{${"serviceReviewId"}}`, encodeURIComponent(String(serviceReviewId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateServiceReviewCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ServiceReviewsApi - functional programming interface
 * @export
 */
export const ServiceReviewsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ServiceReviewsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all ServiceReviews.
         * @param {string} [id] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [patientId] 
         * @param {string} [patientName] 
         * @param {Gender} [gender] 
         * @param {boolean} [recommended] 
         * @param {number} [rate] 
         * @param {ReviewType} [reviewType] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsGet(id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsGet(id, serviceId, serviceName, hospitalId, hospitalName, patientId, patientName, gender, recommended, rate, reviewType, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a ServiceReview.
         * @param {CreateServiceReviewCommand} [createServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsPost(createServiceReviewCommand?: CreateServiceReviewCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsPost(createServiceReviewCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete ServiceReview.
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId, languageCode, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary 
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdGet(serviceReviewId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdGet(serviceReviewId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all ServiceReviewMedias.
         * @param {string} serviceReviewId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete ServiceReviewMedia
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update ServiceReview.
         * @param {string} serviceReviewId 
         * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicereviewsServiceReviewIdPut(serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceReviewModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicereviewsServiceReviewIdPut(serviceReviewId, updateServiceReviewCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ServiceReviewsApi - factory interface
 * @export
 */
export const ServiceReviewsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ServiceReviewsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all ServiceReviews.
         * @param {string} [id] 
         * @param {string} [serviceId] 
         * @param {string} [serviceName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [patientId] 
         * @param {string} [patientName] 
         * @param {Gender} [gender] 
         * @param {boolean} [recommended] 
         * @param {number} [rate] 
         * @param {ReviewType} [reviewType] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsGet(id?: string, serviceId?: string, serviceName?: string, hospitalId?: string, hospitalName?: string, patientId?: string, patientName?: string, gender?: Gender, recommended?: boolean, rate?: number, reviewType?: ReviewType, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ServiceReviewsModel> {
            return localVarFp.apiV1ServicereviewsGet(id, serviceId, serviceName, hospitalId, hospitalName, patientId, patientName, gender, recommended, rate, reviewType, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a ServiceReview.
         * @param {CreateServiceReviewCommand} [createServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsPost(createServiceReviewCommand?: CreateServiceReviewCommand, options?: any): AxiosPromise<ServiceReviewModel> {
            return localVarFp.apiV1ServicereviewsPost(createServiceReviewCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete ServiceReview.
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId: string, languageCode?: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdDelete(serviceReviewId, languageCode, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 
         * @param {string} serviceReviewId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdGet(serviceReviewId: string, languageCode?: string, options?: any): AxiosPromise<ServiceReviewModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdGet(serviceReviewId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all ServiceReviewMedias.
         * @param {string} serviceReviewId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdMediasGet(serviceReviewId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete ServiceReviewMedia
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(serviceReviewId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(serviceReviewId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(serviceReviewId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create ServiceReviewMedia.
         * @param {string} serviceReviewId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdMediasPost(serviceReviewId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update ServiceReview.
         * @param {string} serviceReviewId 
         * @param {UpdateServiceReviewCommand} [updateServiceReviewCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicereviewsServiceReviewIdPut(serviceReviewId: string, updateServiceReviewCommand?: UpdateServiceReviewCommand, options?: any): AxiosPromise<ServiceReviewModel> {
            return localVarFp.apiV1ServicereviewsServiceReviewIdPut(serviceReviewId, updateServiceReviewCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ServicereviewsGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly serviceId?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly serviceName?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly patientId?: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly patientName?: string

    /**
     * 
     * @type {Gender}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly recommended?: boolean

    /**
     * 
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly rate?: number

    /**
     * 
     * @type {ReviewType}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly reviewType?: ReviewType

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ServiceReviewsApiApiV1ServicereviewsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ServicereviewsPost operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsPostRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsPostRequest {
    /**
     * 
     * @type {CreateServiceReviewCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsPost
     */
    readonly createServiceReviewCommand?: CreateServiceReviewCommand
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdDelete operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGet
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDelete
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdGet operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGet
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasMediaIdPut operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdMediasPost operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPost
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1ServicereviewsServiceReviewIdPut operation in ServiceReviewsApi.
 * @export
 * @interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest
 */
export interface ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPut
     */
    readonly serviceReviewId: string

    /**
     * 
     * @type {UpdateServiceReviewCommand}
     * @memberof ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPut
     */
    readonly updateServiceReviewCommand?: UpdateServiceReviewCommand
}

/**
 * ServiceReviewsApi - object-oriented interface
 * @export
 * @class ServiceReviewsApi
 * @extends {BaseAPI}
 */
export class ServiceReviewsApi extends BaseAPI {
    /**
     * 
     * @summary Get all ServiceReviews.
     * @param {ServiceReviewsApiApiV1ServicereviewsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsGetRequest = {}, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsGet(requestParameters.id, requestParameters.serviceId, requestParameters.serviceName, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.patientId, requestParameters.patientName, requestParameters.gender, requestParameters.recommended, requestParameters.rate, requestParameters.reviewType, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsPost(requestParameters: ServiceReviewsApiApiV1ServicereviewsPostRequest = {}, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsPost(requestParameters.createServiceReviewCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdDelete(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdDeleteRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdDelete(requestParameters.serviceReviewId, requestParameters.languageCode, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdGetRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdGet(requestParameters.serviceReviewId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all ServiceReviewMedias.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdMediasGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasGetRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdMediasGet(requestParameters.serviceReviewId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete ServiceReviewMedia
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdMediasMediaIdDelete(requestParameters.serviceReviewId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdMediasMediaIdGet(requestParameters.serviceReviewId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdMediasMediaIdPut(requestParameters.serviceReviewId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create ServiceReviewMedia.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdMediasPost(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdMediasPostRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdMediasPost(requestParameters.serviceReviewId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update ServiceReview.
     * @param {ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServiceReviewsApi
     */
    public apiV1ServicereviewsServiceReviewIdPut(requestParameters: ServiceReviewsApiApiV1ServicereviewsServiceReviewIdPutRequest, options?: AxiosRequestConfig) {
        return ServiceReviewsApiFp(this.configuration).apiV1ServicereviewsServiceReviewIdPut(requestParameters.serviceReviewId, requestParameters.updateServiceReviewCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
