/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { HospitalServiceModel } from '../models';
// @ts-ignore
import { HospitalServicesModel } from '../models';
// @ts-ignore
import { MarketingType } from '../models';
// @ts-ignore
import { Procedure } from '../models';
/**
 * ServicesApi - axios parameter creator
 * @export
 */
export const ServicesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all HospitalServices.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceCategoryId] 
         * @param {MarketingType} [marketingType] 
         * @param {Procedure} [procedure] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesGet: async (id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/services`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (slug !== undefined) {
                localVarQueryParameter['Slug'] = slug;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (hospitalSlug !== undefined) {
                localVarQueryParameter['HospitalSlug'] = hospitalSlug;
            }

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (specialtyName !== undefined) {
                localVarQueryParameter['SpecialtyName'] = specialtyName;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (specialtyTypeName !== undefined) {
                localVarQueryParameter['SpecialtyTypeName'] = specialtyTypeName;
            }

            if (serviceCategoryId !== undefined) {
                localVarQueryParameter['ServiceCategoryId'] = serviceCategoryId;
            }

            if (marketingType !== undefined) {
                localVarQueryParameter['MarketingType'] = marketingType;
            }

            if (procedure !== undefined) {
                localVarQueryParameter['Procedure'] = procedure;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Service by ServiceId
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesServiceIdGet: async (serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceId' is not null or undefined
            assertParamExists('apiV1ServicesServiceIdGet', 'serviceId', serviceId)
            const localVarPath = `/api/v1/services/{serviceId}`
                .replace(`{${"serviceId"}}`, encodeURIComponent(String(serviceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Service by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1ServicesSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/services/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ServicesApi - functional programming interface
 * @export
 */
export const ServicesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ServicesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all HospitalServices.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceCategoryId] 
         * @param {MarketingType} [marketingType] 
         * @param {Procedure} [procedure] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicesGet(id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServicesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicesGet(id, name, slug, hospitalId, hospitalName, hospitalSlug, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceCategoryId, marketingType, procedure, created, showHidden, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Service by ServiceId
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicesServiceIdGet(serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServiceModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicesServiceIdGet(serviceId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Service by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServiceModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicesSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ServicesApi - factory interface
 * @export
 */
export const ServicesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ServicesApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all HospitalServices.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [hospitalSlug] 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [specialtyTypeId] 
         * @param {string} [specialtyTypeName] 
         * @param {string} [serviceCategoryId] 
         * @param {MarketingType} [marketingType] 
         * @param {Procedure} [procedure] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesGet(id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalServicesModel> {
            return localVarFp.apiV1ServicesGet(id, name, slug, hospitalId, hospitalName, hospitalSlug, specialtyId, specialtyName, specialtyTypeId, specialtyTypeName, serviceCategoryId, marketingType, procedure, created, showHidden, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Service by ServiceId
         * @param {string} serviceId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesServiceIdGet(serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<HospitalServiceModel> {
            return localVarFp.apiV1ServicesServiceIdGet(serviceId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Service by slug
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<HospitalServiceModel> {
            return localVarFp.apiV1ServicesSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ServicesGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesGetRequest
 */
export interface ServicesApiApiV1ServicesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly slug?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalSlug?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyName?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyTypeId?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyTypeName?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly serviceCategoryId?: string

    /**
     * 
     * @type {MarketingType}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly marketingType?: MarketingType

    /**
     * 
     * @type {Procedure}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly procedure?: Procedure

    /**
     * 
     * @type {Date}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ServicesServiceIdGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesServiceIdGetRequest
 */
export interface ServicesApiApiV1ServicesServiceIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly serviceId: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1ServicesSlugGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesSlugGetRequest
 */
export interface ServicesApiApiV1ServicesSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * ServicesApi - object-oriented interface
 * @export
 * @class ServicesApi
 * @extends {BaseAPI}
 */
export class ServicesApi extends BaseAPI {
    /**
     * 
     * @summary Get all HospitalServices.
     * @param {ServicesApiApiV1ServicesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    public apiV1ServicesGet(requestParameters: ServicesApiApiV1ServicesGetRequest = {}, options?: AxiosRequestConfig) {
        return ServicesApiFp(this.configuration).apiV1ServicesGet(requestParameters.id, requestParameters.name, requestParameters.slug, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.hospitalSlug, requestParameters.specialtyId, requestParameters.specialtyName, requestParameters.specialtyTypeId, requestParameters.specialtyTypeName, requestParameters.serviceCategoryId, requestParameters.marketingType, requestParameters.procedure, requestParameters.created, requestParameters.showHidden, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Service by ServiceId
     * @param {ServicesApiApiV1ServicesServiceIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    public apiV1ServicesServiceIdGet(requestParameters: ServicesApiApiV1ServicesServiceIdGetRequest, options?: AxiosRequestConfig) {
        return ServicesApiFp(this.configuration).apiV1ServicesServiceIdGet(requestParameters.serviceId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Service by slug
     * @param {ServicesApiApiV1ServicesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    public apiV1ServicesSlugGet(requestParameters: ServicesApiApiV1ServicesSlugGetRequest, options?: AxiosRequestConfig) {
        return ServicesApiFp(this.configuration).apiV1ServicesSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }
}
